{--------------------------------------------------------}
{
{    Programa para emissao de cheques
{
{    Mdulo de variveis
{
{    Autor: Antonio Borges
{
{    Em Agosto de 2001
{
{--------------------------------------------------------}

{$N+}

unit chConfig;

interface
uses dvcrt, dvwin, dvForm, windows, sysUtils,
     chvars, chmsg, chImprim;

procedure configura;
procedure configInicial;
procedure carregaBanco (nome: string);
procedure guardaBanco (nome: string);
procedure geraBancoPadrao (nome, nomeArq: string);

implementation

{--------------------------------------------------------}

procedure geraSaldoAnterior;
var arqLanc: text;
begin
    assign (arqLanc, nomeArqLanc);

    {$I-} reset (arqLanc);  {$I+}      {'no recria arquivo se ele j existia'}
    if ioresult = 0 then
        begin
            close (arqLanc);
            exit;
        end;

    {$I-} rewrite (arqLanc);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('CHLANNAT', 1);  {'Erro no arquivo de lanamentos.'}
            exit;
        end;

    writeln (arqLanc, '          ');
    writeln (arqLanc, 'Saldo Anterior');
    writeln (arqLanc, '0,00');
    writeln (arqLanc, 'C');
    writeln (arqLanc, '');
    writeln (arqLanc, '');
    writeln (arqLanc, '');
    writeln (arqLanc, 'Saldo Anterior');
    writeln (arqLanc, '----------------------------------------');
    close (arqLanc);
end;

{--------------------------------------------------------}

procedure acertaNomeArq (var nomeNovo: string);
var nomeDir: string;
begin
    if pos ('\', nomeNovo) = 0 then
        begin
            getDir (0, nomeDir);
            if nomeDir [length (nomeDir)] <> '\' then
                nomeDir := nomeDir + '\';
            nomeNovo := nomeDir + nomeNovo;
        end;

    if pos ('.', nomeNovo) = 0 then
        nomeNovo := nomeNovo + '.CHQ';
end;

{--------------------------------------------------------}

procedure configInicial;
var
    pBanco: array [0..100] of char;
    pConf: array [0..4000] of char;
begin
    moeda  := sintAmbiente ('CHEQVOX', 'MOEDA');    {no Brasil sempre muda...}
    moedas := sintAmbiente ('CHEQVOX', 'MOEDAS');
    if (moeda = '') or (moedas = '') then
        begin
            moeda := 'real';
            moedas := 'reais';
            writePrivateProfileString ('CHEQVOX', 'MOEDA', 'real', 'DOSVOX.INI');
            writePrivateProfileString ('CHEQVOX', 'MOEDAS', 'reais', 'DOSVOX.INI');
        end;

    bancoAtual := sintAmbiente ('CHEQVOX', 'BANCOATUAL');
    strPCopy (pbanco, bancoAtual);
    getPrivateProfileString (pbanco, 'ano4Digitos', '', pConf, 80, 'CHEQVOX.INI');

    if (bancoAtual = '') or (pConf [0] = #$0) then
	begin
	    bancoAtual := 'Banco do Brasil';
            nomeArqLanc := 'brasil.chq';
            acertaNomeArq (nomeArqLanc);
	    geraBancoPadrao (bancoAtual, nomeArqLanc);
            geraSaldoAnterior;
	end;

    carregaBanco (bancoAtual);

    strPCopy (pbanco, 'Cheque Vox ' + bancoAtual);
    setWindowText (crtWindow, pbanco);

    nome       := sintAmbiente ('CHEQVOX', 'Nome');
    identidade := sintAmbiente ('CHEQVOX', 'Identidade');
    expedidor  := sintAmbiente ('CHEQVOX', 'Expedidor');
    cpf        := sintAmbiente ('CHEQVOX', 'CPF');
    endereco   := sintAmbiente ('CHEQVOX', 'Endereco');
    telefone   := sintAmbiente ('CHEQVOX', 'Telefone');
    bairro     := sintAmbiente ('CHEQVOX', 'Bairro');
    cidade     := sintAmbiente ('CHEQVOX', 'Cidade');

    if nome = '' then
	mensagem ('CHEXECAD', 2);     {'Ateno: informaes incompletas, atualize seus dados pessoais'}

    mensagem ('CHBANATU', 0);    {'Banco atual: '}
    sintWriteln (bancoAtual);
end;

{--------------------------------------------------------}

procedure guardaBanco (nome: string);
const
    pSim: pchar = 'S';
    pNao: pchar = 'N';

var
    pbanco: array [0..100] of char;
    pch: pchar;
    p: array [0..100] of char;

    function CoordToPchar (xy: TCoord): pchar;
    var s1, s2: string;
    begin
	str (xy.x, s1);
	str (xy.y, s2);
	strPCopy (p, s1+','+s2);
	coordToPchar := p;
    end;

begin
    if nome = '' then exit;

    strPCopy (pbanco, nome);
    writePrivateProfileString ('Bancos', pbanco, '', 'CHEQVOX.INI');

    strPCopy (p, nomeArqLanc);
    writePrivateProfileString (pbanco, 'arquivoLanc', p, 'CHEQVOX.INI');
    if ano4Digitos then pch := pSim
                   else pch := pNao;
    writePrivateProfileString (pbanco, 'ano4Digitos',  pch, 'CHEQVOX.INI');
    if deitado then pch := pSim
	       else pch := pNao;
    writePrivateProfileString (pbanco, 'imprimeDeitado', pch, 'CHEQVOX.INI');

    writePrivateProfileString (pbanco, 'ajusteMM',      coordToPchar (ajusteMM),      'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posValor',      coordToPchar (posValor),      'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posExtenso1',   coordToPchar (posExtenso1),   'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posExtenso2',   coordToPchar (posExtenso2),   'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posFavorecido', coordToPchar (posFavorecido), 'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posCidade',     coordToPchar (posCidade),     'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posDia',        coordToPchar (posDia),        'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posMes',        coordToPchar (posMes),        'CHEQVOX.INI');
    writePrivateProfileString (pbanco, 'posAno',        coordToPchar (posAno),        'CHEQVOX.INI');

end;

{--------------------------------------------------------}

procedure carregaBanco (nome: string);
const
    pSim: pchar = 'S';
    pNao: pchar = 'N';

var
    pbanco: array [0..100] of char;
    pch: array [0..100] of char;

    procedure pcharToCoord (p: pchar; var coord: TCoord);
    var n: integer;
    begin
        while (p^ <> #$0) and (not (p^ in ['0'..'9'])) do
            p := p + 1;
        n := 0;
        while (p^ <> #$0) and (p^ in ['0'..'9']) do
            begin
                n := n * 10 + (ord (p^) - ord ('0'));
                p := p + 1;
            end;
        coord.x := n;

        while (p^ <> #$0) and (not (p^ in ['0'..'9'])) do
            p := p + 1;
        n := 0;
        while (p^ <> #$0) and (p^ in ['0'..'9']) do
            begin
                n := n * 10 + (ord (p^) - ord ('0'));
                p := p + 1;
            end;

        coord.y := n;
    end;

begin
    strPCopy (pbanco, nome);

    getPrivateProfileString (pbanco, 'arquivoLanc',    '', pch, 80, 'CHEQVOX.INI');
    nomeArqLanc := strPas (pch);
    getPrivateProfileString (pbanco, 'ano4Digitos',    'S', pch, 80, 'CHEQVOX.INI');
    ano4Digitos := upcase (pch[0]) <> 'N';
    getPrivateProfileString (pbanco, 'imprimeDeitado', 'N', pch, 80, 'CHEQVOX.INI');
    deitado := upcase (pch[0]) <> 'N';

    getPrivateProfileString (pbanco, 'ajusteMM',      '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, ajusteMM);
    getPrivateProfileString (pbanco, 'posValor',      '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posValor);
    getPrivateProfileString (pbanco, 'posExtenso1',   '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posExtenso1);
    getPrivateProfileString (pbanco, 'posExtenso2',   '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posExtenso2);
    getPrivateProfileString (pbanco, 'posFavorecido', '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posFavorecido);
    getPrivateProfileString (pbanco, 'posCidade',     '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posCidade);
    getPrivateProfileString (pbanco, 'posDia',        '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posDia);
    getPrivateProfileString (pbanco, 'posMes',        '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posMes);
    getPrivateProfileString (pbanco, 'posAno',        '0,0', pch, 100, 'CHEQVOX.INI');
    pcharToCoord (pch, posAno);

    strPCopy (pbanco, nome);
    writePrivateProfileString ('CHEQVOX', 'BANCOATUAL', pbanco, 'DOSVOX.INI');
    bancoAtual := nome;
end;

{--------------------------------------------------------}

procedure geraPosicoesPadrao;
begin
    { dados em milmetros }
    ajusteMM.x := 0;         ajusteMM.y := 0;
    posValor.x := 130;       posValor.y := 0;
    posExtenso1.x := 26;     posExtenso1.y := 6;
    posExtenso2.x := 8;      posExtenso2.y := 12;
    posFavorecido.x := 8;    posFavorecido.y := 18;
    posCidade.x := 70;       posCidade.y := 25;
    posDia.x := 108;         posDia.y := 25;
    posMes.x := 125;         posMes.y := 25;
    posAno.x := 157;         posAno.y := 25;
end;

{--------------------------------------------------------}

procedure geraBancoPadrao (nome, nomeArq: string);
begin
    geraPosicoesPadrao;
    ano4digitos := true;
    deitado := true;
    nomeArqLanc := nomeArq;

    guardaBanco (nome);
end;

{--------------------------------------------------------}

procedure dadosPessoais;
var sz: array [0..100] of char;
begin
    clrscr;
    writeln ('Cheque Vox');
    writeln;
    mensagem ('CHALTPES', 2);   {'Use as setas para alterar os dados pessoais, ESC termina'}
    formCria;
    formCampo ('CHNOME',   'Nome', nome, 50);
    formCampo ('CHIDENT',  'Identidade', identidade, 20);
    formCampo ('CHEXPEDI', 'Expedidor', expedidor, 20);
    formCampo ('CHCPF',    'CPF', cpf, 20);
    formCampo ('CHTELEFO', 'Telefone', telefone, 20);
    formCampo ('CHENDERE', 'Endereo', endereco, 50);
    formCampo ('CHBAIRRO', 'Bairro', bairro, 40);
    formCampo ('CHCIDADE', 'Cidade', cidade, 40);
    formEdita (true);

    strPCopy (sz, nome);
    writePrivateProfileString ('CHEQVOX', 'Nome', sz, 'DOSVOX.INI');
    strPCopy (sz, identidade);
    writePrivateProfileString ('CHEQVOX', 'Identidade', sz, 'DOSVOX.INI');
    strPCopy (sz, expedidor);
    writePrivateProfileString ('CHEQVOX', 'Expedidor', sz, 'DOSVOX.INI');
    strPCopy (sz, cpf);
    writePrivateProfileString ('CHEQVOX', 'CPF', sz, 'DOSVOX.INI');
    strPCopy (sz, telefone);
    writePrivateProfileString ('CHEQVOX', 'Telefone', sz, 'DOSVOX.INI');
    strPCopy (sz, endereco);
    writePrivateProfileString ('CHEQVOX', 'Endereco', sz, 'DOSVOX.INI');
    strPCopy (sz, bairro);
    writePrivateProfileString ('CHEQVOX', 'Bairro', sz, 'DOSVOX.INI');
    strPCopy (sz, cidade);
    writePrivateProfileString ('CHEQVOX', 'Cidade', sz, 'DOSVOX.INI');

    writeln;
    mensagem ('CHOKCONF', 1);   {'Ok, configurado'}
end;

{--------------------------------------------------------}

function selecionaUmBanco: string;
var
    qual: integer;
    i, nbancos: integer;
    vet: array [0..4000] of char;
    vetBancos: array [1..1000] of pchar;
    p: pchar;

begin
    GetPrivateProfileString('Bancos', NIL, '', vet, 4000, 'CHEQVOX.INI');
    p := vet;
    nbancos := 0;
    while p^ <> #$0 do
        begin
            nbancos := nbancos + 1;
            vetBancos [nbancos] := p;
            p := p + strlen (p) + 1;
        end;

    if nbancos = 0 then
        begin
            selecionaUmbanco := '';
            mensagem ('CHSEMREG', 1);   {'Nenhum banco foi registrado'}
            exit;
        end;

    for i := 1 to nbancos do writeln;
    gotoxy (1, wherey-nbancos-1);
    mensagem ('CHSELBNK', 1);   {'Use as setas para selecionar o banco, ENTER termina'}

    opcoesCria (1, wherey, 60);
    for i := 1 to nbancos do
	opcoesAdiciona ('', strPas (vetBancos[i]));
    qual := opcoesSeleciona;

    if qual = 0 then
        begin
            mensagem ('CHDESIST', 1);          {'Desistiu...'}
            selecionaUmbanco := '';
        end
    else
        selecionaUmbanco := strPas (vetBancos[qual]);
end;

{--------------------------------------------------------}

procedure trocaBancoAtual;
var nomeEscolhido: string;
begin
    nomeEscolhido := selecionaUmBanco;
    if nomeEscolhido <> '' then
	begin
	    bancoAtual := nomeEscolhido;
            carregaBanco (bancoAtual);

	    mensagem ('CHBANATU', 0);    {'Banco atual: '}
	    sintWriteln (bancoAtual);
	    writeln;
	    mensagem ('CHOKCONF', 1);   {'Ok, configurado'}
	end;
end;

{--------------------------------------------------------}

procedure removeBanco;
var nomeEscolhido: string;
    pbanco: array [0..100] of char;
begin
    nomeEscolhido := selecionaUmBanco;
    if nomeEscolhido = '' then exit;

    strPCopy (pbanco, nomeEscolhido);
    writePrivateProfileString('Bancos', pbanco, NIL, 'CHEQVOX.INI');

    if nomeEscolhido = bancoAtual then
        begin
            bancoAtual := '';
            mensagem ('CHCNFNOV', 1);  {'Ateno, configure o banco atual'}
        end;
end;

{--------------------------------------------------------}

procedure criaNovoBanco;
var nome: string;
    pbanco, sz: array [0..100] of char;
begin
    mensagem ('CHNOVBNK', 1);     {'Informe o nome do novo banco'}
    sintReadln (nome);
    if nome = '' then
        begin
            mensagem ('CHDESIST', 1);   {'Desistiu'}
            exit;
        end;

    strPCopy (pbanco, nome);
    WritePrivateProfileString('Bancos', pbanco, '', 'CHEQVOX.INI');

    if getPrivateProfileString(pbanco, 'posValor', '', sz, 10, 'CHEQVOX.INI') <> 0 then
        mensagem ('CHPREVRG', 1)   {'Ateno, este banco havia sido anteriormente cadastrado'}
    else
        begin
            mensagem ('CHINFARQ', 1);  {'Informe o nome do arquivo de registro (sugiro usar extenso .chq):'}
            sintReadln (nomeArqLanc);
            acertaNomeArq (NomeArqLanc);

            geraBancoPadrao (nome, nomeArqLanc);
            geraSaldoAnterior;
        end;

    carregaBanco (nome);

    mensagem ('CHBANATU', 0);    {'Banco atual: '}
    sintWriteln (bancoAtual);
end;

{--------------------------------------------------------}

procedure ajustaPosicoes;

    procedure ajusta (var v: TCoord);
    var op: integer;
        n: integer;
    begin
        mensagem ('CHATUALM', 0);      {' atualmente '}
        sintWriteint (v.x);
        write (', ');
        sintWriteint (v.y);
        writeln;

        mensagem ('CHSELDSL', 1);      {'Escolha com as setas a direo a deslocar e aperte enter'}
        opcoesCria (wherex, wherey, 8);
        opcoesAdiciona ('CHESQ',   'Esquerda');
        opcoesAdiciona ('CHDIR',   'Direita');
        opcoesAdiciona ('CHCIMA',  'Cima');
        opcoesAdiciona ('CHBAIXO', 'Baixo');
        op := opcoesSeleciona;

        if op = 0 then exit;

        mensagem ('CHINFMIL', 0);       {'Quantos milmetros desloco ? '}
        sintReadint (n);
        writeln;

        case op of
            1: v.x := v.x - n;
            2: v.x := v.x + n;
            3: v.y := v.y - n;
            4: v.y := v.y + n;
        end;
        mensagem ('CHOK', 1);   {'OK.'}
    end;

var op: integer;
begin
    repeat
        clrscr;
        mensagem ('CHDESAJU', 1);  {'Selecione com as setas o campo desajustado e aperte enter'}
        mensagem ('CHTERESC', 2);  {'Termine com ESC'}

        opcoesCria (wherex, wherey, 23);
        opcoesAdiciona ('CHVALOR',  'Valor');
        opcoesAdiciona ('CHEXT1',   'Primeiro nmero extenso');
        opcoesAdiciona ('CHEXT2',   'Segundo nmero extenso');
        opcoesAdiciona ('CHFAVORE', 'Favorecido');
        opcoesAdiciona ('CHCIDADE', 'Cidade');
        opcoesAdiciona ('CHDIA',    'Dia');
        opcoesAdiciona ('CHMES',    'Ms');
        opcoesAdiciona ('CHANO',    'Ano');
        op := opcoesSeleciona;

        writeln;

        case op of
             0: mensagem ('CHPOSALT', 2);  {'Posies de impresso foram alteradas.'}
             1: ajusta (posValor);
             2: ajusta (posExtenso1);
             3: ajusta (posExtenso2);
             4: ajusta (posFavorecido);
             5: ajusta (posCidade);
             6: ajusta (posDia);
             7: ajusta (posMes);
             8: ajusta (posAno);
        end;
    until op = 0;
end;

{--------------------------------------------------------}

procedure configBanco;
var restaura: boolean;
    c, c2: char;
    nomeNovo: string;
label fimConf;
begin
    writeln;
    sintBip;
    restaura := false;

    mensagem ('CHARQATU', 1);  {'O nome do arquivo de lanamentos '}
    sintWriteln (nomearqLanc);
    mensagem ('CHDESALT', 0);  {'Deseja trocar de arquivo? '}
    sintLetecla (c, c2);
    writeln;
    writeln;

    if upcase (c) = 'S' then
        begin
            mensagem ('CHDIGNOM', 1);  {'Digite o novo nome do arquivo atual (use extenso .CHQ)'}
            sintReadln (nomeNovo);

            while (nomeNovo <> '') and (nomeNovo[1] = ' ') do delete (nomeNovo, 1, 1);
            if nomeNovo = '' then
                mensagem ('CHDESIST', 1)   {'Desistiu'}
            else
                begin
                    acertaNomeArq (nomeNovo);
                    nomeArqLanc := nomeNovo;
                    geraSaldoAnterior;
                    mensagem ('CHOK', 2);   {'OK'}
                end;
        end;

    mensagem ('CHCNFPOS', 0);  {'Quer configurar a impresso? '}
    sintLetecla (c, c2);
    writeln;
    if upcase (c) = 'N' then goto fimConf;

    clrscr;
    mensagem ('CHCNFIMP', 2);  {'Configurao da impresso'}
    mensagem ('CHPFMESC', 2);  {'Preencha o formulrio a seguir, termine com ESC'}

    formCria;
    formCampoBool ('CHANO4',   'Escreve ano com 4 digitos',   ano4Digitos);
    formCampoBool ('CHIMPDEI', 'Imprime cheque deitado',      deitado);
    formCampoBool ('CHRESTAU', 'Restaura valores de fbrica', restaura);
    formCampoInt  ('CHMILDIR', 'Milmetros para a direita',   ajusteMM.x);
    formCampoInt  ('CHMILBAI', 'Milmetros para baixo',       ajusteMM.y);
    formEdita (true);

    if restaura then
        geraPosicoesPadrao;

    writeln;
    mensagem ('CHAJUSP', 1);   {'Ajustando posies de escrita.'}
    mensagem ('CHREGUA', 1);   {'Algum vai ajud-lo a medir com uma rgua.'}

    repeat
        writeln;
        imprimeModelo;

        mensagem ('CHMODOK', 0);   {'O modelo foi impresso nas posies corretas?'}
        sintLetecla (c, c2);
        writeln;
        c := upcase (c);
        if c = 'N' then
            ajustaPosicoes;
    until c <> 'N';

fimConf:
    writeln;
    guardaBanco (bancoAtual);
    mensagem ('CHOKCONF', 1);   {'Ok, configurado'}
end;

{--------------------------------------------------------}
{            seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;

    procedure MenuAdiciona (msg: string);
    begin
         popupMenuAdiciona (msg, pegaTextoMensagem (msg));
    end;

var n: integer;
const
    tabLetrasOpcoes: string [5] = 'pnbcr';

begin
    garanteEspacoTela(5);
    popupMenuCria (wherex, wherey, 50, 5, MAGENTA);
    MenuAdiciona ('CHAJC1'); {'   P    altera dados pessoais'}
    MenuAdiciona ('CHAJC2'); {'   N    registra novo banco'}
    MenuAdiciona ('CHAJC3'); {'   B    troca banco atual'}
    MenuAdiciona ('CHAJC4'); {'   C    altera a configurao do banco atual'}
    MenuAdiciona ('CHAJC5'); {'   R    remove um banco registrado'}
    n := popupMenuSeleciona;
    if n > 0 then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{--------------------------------------------------------}

procedure ajuda;
begin
    mensagem ('CHAJC0', 1); {'As opes de configurao so:'}
    mensagem ('CHAJC1', 1); {'   P    altera dados pessoais'}
    mensagem ('CHAJC2', 1); {'   N    registra novo banco'}
    mensagem ('CHAJC3', 1); {'   B    troca banco atual'}
    mensagem ('CHAJC4', 1); {'   C    altera a configurao do banco atual'}
    mensagem ('CHAJC5', 1); {'   R    remove um banco registrado'}
    mensagem ('CHAJC9', 1); {'   ESC  fim das configuraes'}
    while keypressed do readkey;
    sintBip;
end;

{--------------------------------------------------------}
{               configurao
{--------------------------------------------------------}

procedure configura;
var c, c2: char;
    fimConf: boolean;
label executa;
begin
    fimConf := false;
    repeat
        writeln;
        textBackground (MAGENTA);
        mensagem ('CHOPCONF', 0);   {'O que deseja configurar?'}
        textBackground (BLACK);
        sintLeTecla (c, c2);
        writeln;

        if c = #$0 then
            begin
                if (c2 = F1) then
                    ajuda
                else
                if (c2 = CIMA) or (c2 = BAIX) then
                    begin
                        c := selSetasOpcao;
                        goto executa;
                    end;
            end
        else
            begin
    executa:
                case upcase(c) of
                    'P': dadosPessoais;
                    'B': trocaBancoAtual;
                    'N': criaNovoBanco;
                    'C': configBanco;
                    'R': removeBanco;
                    ESC: fimConf := true;
                else
                    mensagem ('CHOPINV', 1);  {'Opo invlida, aperte F1 para ajuda'}
                end;
            end;
    until fimConf;
end;

end.
